EDIT - feature request #6694
feature request # 6565 (Closed): [MASTER] Eclipse 4 Migration

Migrate FeatureTreeEditor
06/06/2017 12:03 PM - Patrick Plitzner

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Patrick Plitzner % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.8

Severity: critical

Description

This should also be implemented or moved outside of the preferences

Related issues:

Related to EDIT - bug #6726: NPE in FactualDataView and feature selection doe... Closed
Related to EDIT - feature request #6805: Implement drag and drop from Term Ed... Closed
Related to EDIT - feature request #6806: Add context menu to FeatureTreeEditor Closed
Related to EDIT - bug #6838: Implement i18n for FeatureTreeEditor Closed
Related to EDIT - bug #6844: New feature tree selection does not allow "no save" Rejected
Related to EDIT - bug #6845: dirty button does not work in feature tree editor Worksforme
Precedes EDIT - bug #6786: Remaining feature tree editor issues Closed

Associated revisions

Revision 5ce82a07 - 06/06/2017 02:41 PM - Patrick Plitzner
ref #6694 Implement Feature Tree Editor

Revision 880044bc - 06/06/2017 03:32 PM - Patrick Plitzner
ref #6694 Handle dirty state when adding/removing features

Revision cc4535d4 - 06/07/2017 10:59 AM - Patrick Plitzner

ref #6694 Improve Ul and feature tree creation

Revision d455719e - 06/07/2017 11:11 AM - Patrick Plitzner

ref #6694 Set pattern when creating a new feature tree

Revision 4aca5046 - 06/07/2017 11:45 AM - Patrick Plitzner

ref #6694 Remove wizard pages and plugin configurations

Revision f716539d - 06/16/2017 02:19 PM - Patrick Plitzner
ref #6694 Set FeatureTree editor dirty after drag and drop

Revision 4d98dfd9 - 06/16/2017 02:49 PM - Patrick Plitzner

ref #6694 Implement selection propagation in feature tree editor

Revision f08ae629 - 06/16/2017 03:15 PM - Patrick Plitzner

ref #6694 Remove moved feature node after drag and drop

Revision 94681750 - 06/16/2017 03:23 PM - Patrick Plitzner

ref #6694 Beautify alignment of feature tree editor

Revision bc00fbdf - 06/16/2017 03:45 PM - Patrick Plitzner

ref #6694 Move menu item to "Term Editor"
Revision 34fd7a1c - 06/19/2017 10:59 AM - Patrick Plitzner

ref #6694 Extract composite and Listeners from FeatureTreeEditor

Revision 229af84a - 06/20/2017 10:16 AM - Patrick Plitzner

ref #6694 Add separator to term menu

Revision cfbd89d6 - 06/20/2017 10:23 AM - Patrick Plitzner

ref #6694 Make text field editable only when feature tree is selected

Revision 4cab9405 - 06/20/2017 02:30 PM - Patrick Plitzner

ref #6694 Extract composite and Listeners from FeatureTreeEditor

Conflicts:

eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/featuretree/
ed4/FeatureTreeEditor.java

Revision 489923b4 - 06/20/2017 04:43 PM - Patrick Plitzner

ref #6694 Add service method to move FeatureNodes

Revision 50c9803d - 06/20/2017 04:43 PM - Patrick Plitzner

ref #6694 Fix session handling when moving feature nodes

Revision 8b0c4c63 - 06/20/2017 06:31 PM - Patrick Plitzner
ref #6694 Fix drag and drop behavior

Revision 0196a8bf - 06/20/2017 06:31 PM - Patrick Plitzner

ref #6694 Fix moving of feature nodes

Revision 02fbce4a - 06/20/2017 08:27 PM - Patrick Plitzner
ref #6694 110n of FeatureTreeEditor

Revision fbc64294 - 06/21/2017 09:57 AM - Patrick Plitzner
ref #6694 Add service method to add child features

® also add parent of deleted feature node to DeleteResult

Revision 0343d833 - 06/21/2017 10:00 AM - Patrick Plitzner
ref #6694 Add CdmEntitySessionHandling to feature tree editor

Revision 17502849 - 06/21/2017 10:00 AM - Patrick Plitzner

ref #6694 Use service methods to add and remove features

Revision 21fbfba9 - 06/21/2017 10:00 AM - Patrick Plitzner

ref #6694 Always add new features to root node

Revision 349¢3582 - 07/12/2017 01:45 PM - Patrick Plitzner
ref #6694 Adapt to service method changes

Revision 607cfd81 - 07/12/2017 01:46 PM - Patrick Plitzner

ref #6694 Refactor shell access

Revision fe7208bf - 07/12/2017 01:56 PM - Patrick Plitzner
ref #6694 Fix typo in method name

Revision 1ac1ab0b - 07/12/2017 01:58 PM - Patrick Plitzner
ref #6694 Remove cascading to FeatureNodes from Character

Revision da270d9c - 07/12/2017 01:58 PM - Patrick Plitzner
ref #6694 Fix javadoc

Revision 25af2145 - 09/26/2017 01:52 PM - Patrick Plitzner
ref #6694 Fix potential NPE

History

#1 - 06/07/2017 12:04 PM - Patrick Plitzner

- Status changed from New to Resolved

- Assignee changed from Patrick Plitzner to Andreas Mliller

- Target version changed from Unassigned CDM tickets to Release 4.8

- % Done changed from 0 to 80

#2 - 06/14/2017 04:33 PM - Andreas Miiller

- Related to bug #6726: NPE in FactualDataView and feature selection does not show any entries in Factual Data View added

#3 - 06/15/2017 12:27 AM - Andreas Miiller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Patrick Plitzner

Please check #6726 if these bugs are related to the changes in this ticket.

#4 - 06/15/2017 12:37 AM - Andreas Miiller

Please move the menu entry to "Term Editor" and there below "Others" separated with 2 separators; and call in "Feature Tree", not "Feature Tree

Editor".

@Katja: Could you try to implement this already?

#5 - 06/15/2017 12:45 AM - Andreas Miiller

- Severity changed from normal to critical

When moving the Edtior with in the Ul | got an lllegalAurgumentException (Message: null). Title: "Could not get conversatoin for
AbstractFormSection”. Description: "There is an error in the implementation. There should have been an active editor but wasn't".

The error occurred recursively. Showing up in 2 dialogs. One with Details/Error trace, one without (this should not happen). | needed to close it at
least 10x to make it go away completely. The element getting the focus afterwards was a synonym in Name Editor.

java.lang.IllegalArgumentException
at eu.etaxonomy.taxeditor.ui.section.name.NonViralNameDetailElement.setEntity (NonViralNameDetailElement. ja
va:127)

at eu.etaxonomy.taxeditor.ui.section.name.NonViralNameDetailElement.setEntity (NonViralNameDetailElement. ja
va:1)

at eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection.setEntity (AbstractCdmDetailSection. java:125)

at eu.etaxonomy.taxeditor.ui.section.name.NonViralNameDetailSection.setTaxonBase (NonViralNameDetailSection
.Java:129)

at eu.etaxonomy.taxeditor.view.detail.CdmSectionPart.setFormInput (CdmSectionPart. java:91)

at org.eclipse.uil.forms.ManagedForm.setInput (ManagedForm. java:210)

at eu.etaxonomy.taxeditor.view.AbstractCdmDataViewer.refresh (AbstractCdmDataViewer. java:123)

at eu.etaxonomy.taxeditor.view.AbstractCdmDataViewer.setInput (AbstractCdmDataViewer. java:109)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewer.setInput (DetailsViewer. java:161)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewPart.showViewer (DetailsViewPart.java:268)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewPart.selectionChanged_internal (DetailsViewPart.java:136)

at eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart$DelaySelection.run (AbstractCdmEditorViewPart. java
:52)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine.java:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

Setting to critical because of this bug.

#6 - 06/15/2017 12:47 AM - Andreas Miiller

If entering text into the "Title" search box has no effect, the text box should be disabled for entering text.

#7 - 06/15/2017 12:48 AM - Andreas Miiller

Layout: The search box is longer then the textbox for the data. It should be aligned.

#8 - 06/15/2017 12:54 AM - Andreas Mdiller

If moving nodes in the tree everything seems to be saved immediately. This is unexpected behavior as users are used to have to save results of
editing. If this is wanted there should be a warning at least.
Is it necessary that we do not use "save" and set the save button dirty?

#9 - 06/15/2017 12:58 AM - Andreas Miiller
Sometimes there is a bug when moving nodes. The node does not get deleted at the old position but is added at the new position at the same time.
At the same time | also got a never ending resursion as "Conservation" & "Habitat" iterated as being children of each other.
This is difficult to reproduce but similar problems occurred in the old Feature Treee Editor already.
#10 - 06/16/2017 02:57 PM - Patrick Plitzner
- Assignee changed from Patrick Plitzner to Andreas Mliller
Andreas Muller wrote:
If moving nodes in the tree everything seems to be saved immediately. This is unexpected behavior as users are used to have to save results of

editing. If this is wanted there should be a warning at least.
Is it necessary that we do not use "save" and set the save button dirty?

This has been fixed

#11 - 06/16/2017 02:58 PM - Patrick Plitzner
- Assignee changed from Andreas Miiller to Patrick Plitzner
Andreas Milller wrote:

When moving the Edtior with in the Ul | got an lllegalAurgumentException (Message: null). Title: "Could not get conversatoin for
AbstractFormSection”. Description: "There is an error in the implementation. There should have been an active editor but wasn't".

The error occurred recursively. Showing up in 2 dialogs. One with Details/Error trace, one without (this should not happen). | needed to close it at
least 10x to make it go away completely. The element getting the focus afterwards was a synonym in Name Editor.

java.lang.IllegalArgumentException
login : admin
AbstractCdmDataViewer.refresh (AbstractCdmDataViewer. java:123)
AbstractCdmDataViewer.setInput (AbstractCdmDataViewer. java:109)
detail.DetailsViewer.setInput (DetailsViewer. java:161)
detail.DetailsViewPart.showViewer (DetailsViewPart.java:268)
detail.DetailsViewPart.selectionChanged_internal (DetailsViewPart.java:1l

.AbstractCdmEditorViewPart$DelaySelection.run (AbstractCdmEditorViewPart.

.RunnableLock.run (RunnableLock. java:35)
.Synchronizer.runAsyncMessages (Synchronizer. java:182)

.Display.runAsyncMessages (Display.java:4211)
.Display.readAndDispatch (Display.java:3827)

.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run(PartRenderingEngine. java:1121)
.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

This should be fixed by propagating the selection of the editor so that the Details view is emptied.

#12 - 06/16/2017 02:59 PM - Patrick Plitzner

Andreas Muller wrote:

If entering text into the "Title" search box has no effect, the text box should be disabled for entering text.

This is not for searching but for editing the label (titteCache) of the feature tree.

#13 - 06/16/2017 03:16 PM - Patrick Plitzner

Andreas Muller wrote:

Sometimes there is a bug when moving nodes. The node does not get deleted at the old position but is added at the new position at the same

time.

At the same time | also got a never ending resursion as "Conservation" & "Habitat" iterated as being children of each other.

This is difficult to reproduce but similar problems occurred in the old Feature Treee Editor already.
This should also be fixed now. | do not know how to reproduce the recursion but maybe it is fixed as well.

#14 - 06/16/2017 03:46 PM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Andreas Muiller

Andreas Muller wrote:

Please move the menu entry to "Term Editor" and there below "Others" separated with 2 separators; and call in "Feature Tree", not "Feature

Tree Editor".

@Katja: Could you try to implement this already?

All issues mentioned above should be fixed now

#15 - 06/17/2017 11:37 PM - Andreas Miiller

- Status changed from Feedback to Resolved

- Priority changed from New to Highest

#16 - 06/19/2017 12:47 PM - Andreas Miiller

- Status changed from Resolved to Feedback

Patrick Plitzner wrote:

Andreas Muller wrote:

When moving the Edtior with in the Ul | got an lllegalAurgumentException (Message: null). Title: "Could not get conversatoin for
AbstractFormSection". Description: "There is an error in the implementation. There should have been an active editor but wasn't".

The error occurred recursively. Showing up in 2 dialogs. One with Details/Error trace, one without (this should not happen). | needed to
close it at least 10x to make it go away completely. The element getting the focus afterwards was a synonym in Name Editor.
at eu.etaxonomy.taxeditor.view.AbstractCdmDataViewer.setInput (AbstractCdmDataViewer. java:109)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewer.setInput (DetailsViewer. java:161)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewPart.showViewer (DetailsViewPart.java:268)

at eu.etaxonomy.taxeditor.view.detail.DetailsViewPart.selectionChanged_internal (DetailsViewPart. jav

a:136)
at eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart$DelaySelection.run (AbstractCdmEditorViewPa
rt.java:52)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine.java:1121

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

Setting to critical because of this bug.

This should be fixed by propagating the selection of the editor so that the Details view is emptied.

The problem still exists. | moved the Feature Tree Editor from one place to another and then clicked on any feature and it happened (editor version
4.8.0.201706190848)

#17 - 06/19/2017 12:48 PM - Andreas Miiller
- Assignee changed from Andreas Miiller to Patrick Plitzner
Patrick Plitzner wrote:

Andreas Muller wrote:

Please move the menu entry to "Term Editor" and there below "Others" separated with 2 separators; and call in "Feature Tree", not
"Feature Tree Editor".

@Katja: Could you try to implement this already?

All issues mentioned above should be fixed now

The menu is at the right position now, but the 2 separators are still missing
#18 - 06/19/2017 12:54 PM - Andreas Miiller
Patrick Plitzner wrote:

Andreas Miiller wrote:

If entering text into the "Title" search box has no effect, the text box should be disabled for entering text.

This is not for searching but for editing the label (titteCache) of the feature tree.

2 problems:
e even if NO feature tree is selected the field can still be edited (this does not make sense)

e if the search dialog button is just beside the field it is not intuitive that this is an editing field. Search and editing should be clearly separated. Can
we have a search section and an editing section which are separated? Also the search part should have an according label "Search"

#19 - 06/19/2017 12:55 PM - Andreas Miiller

Can you provide according translations for the tab title and the title lable. Something like "Merkmals Baum Editor" und "Merkmals Baum"?
#20 - 06/19/2017 12:58 PM - Andreas Miiller
Patrick Plitzner wrote:

Andreas Miiller wrote:

Sometimes there is a bug when moving nodes. The node does not get deleted at the old position but is added at the new position at the
same time.

At the same time | also got a never ending resursion as "Conservation" & "Habitat" iterated as being children of each other.
This is difficult to reproduce but similar problems occurred in the old Feature Treee Editor already.

This should also be fixed now. | do not know how to reproduce the recursion but maybe it is fixed as well.

| still managed to create 3 nodes for IndividualsAssociations in the same feature tree just by moving around FeatureNodes. This time no recursion
appeared. Still | can't say how to reproduce except for "move nodes often enough, it will occur sooner or later.

#21 - 06/19/2017 01:01 PM - Andreas Miiller
Andreas Muller wrote:
Patrick Plitzner wrote:
Andreas Mller wrote:

Sometimes there is a bug when moving nodes. The node does not get deleted at the old position but is added at the new position at
the same time.

At the same time | also got a never ending resursion as "Conservation" & "Habitat" iterated as being children of each other.

This is difficult to reproduce but similar problems occurred in the old Feature Treee Editor already.

This should also be fixed now. | do not know how to reproduce the recursion but maybe it is fixed as well.

| still managed to create 3 nodes for IndividualsAssociations in the same feature tree just by moving around FeatureNodes. This time no
recursion appeared. Still | can't say how to reproduce except for "move nodes often enough, it will occur sooner or later.

Now | also managed to create recursion. Afterwards | tried to save but pressing the save button had no result. Also trying to close the tab had no
result, no matter if | answered the save request with "save" or cancel".

#22 - 06/20/2017 10:16 AM - Patrick Plitzner
Andreas Muller wrote:
Patrick Plitzner wrote:
Andreas Muller wrote:

Please move the menu entry to "Term Editor" and there below "Others" separated with 2 separators; and call in "Feature Tree", not
"Feature Tree Editor".

@Katja: Could you try to implement this already?

All issues mentioned above should be fixed now

The menu is at the right position now, but the 2 separators are still missing

| added a separator. It seems that RCP will not render two separator after each other by default so there is only one.
#23 - 06/20/2017 10:58 AM - Andreas Miiller
Patrick Plitzner wrote:
Andreas Miiller wrote:
Patrick Plitzner wrote:
The menu is at the right position now, but the 2 separators are still missing

| added a separator. It seems that RCP will not render two separator after each other by default so there is only one.

This is strange as | know for sure that | already saw double separators (and usually didn't like them). Can it be that they came up because there were
menu items in between which where set to invisible in certain surroundings. Is this maybe a work around to add an extra menu item in between and
set it always to invisible?

However, this issue is not release critical, so please first try to solve those issues which are critical.
#24 - 06/20/2017 08:30 PM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Andreas Mliller

- % Done changed from 80 to 90

#25 - 06/21/2017 12:26 AM - Andreas Muller

- Assignee changed from Andreas Miiller to Patrick Plitzner

Now, when trying to add a new feature in the feature tree | always get an LIE
org.hibernate.LazyInitializationException: could not initialize proxy - no Session

at
at
at
at
at

org.hibernate.proxy.AbstractLazyInitializer.initialize (AbstractLazyInitializer.java:148)
org.hibernate.Hibernate.initialize (Hibernate. java:62)
cdm.hibernate.HibernateProxyHelper.deproxy (HibernateProxyHelper. java:45)

eu.etaxonomy.
eu.etaxonomy.
.Jjava:110)
r.java:
org.hibernate.
org.hibernate.
org.hibernate.
org.hibernate.
org.hibernate.
org.hibernate.

org.hibernate.

.Java:249)

at
at

va:121)

at

org.hibernate.
org.hibernate.

org.hibernate

cdm.model.common.CdmBase.deproxy (CdmBase. java:304)

cdm.persistence.

cdm.persistence.

cdm.persistence.

event.internal

.event.internal.

eOrUpdateEventListener. java:192)

at org.hibernate.event.internal.
stener.

at

java:38)

org.hibernate.

tListener.java:177)

at
:32)
at

stener.

at
at
at
at
at
at
at
at
at
at
at
at

org.hibernate.

org.hibernate.

java:73)

org.hibernate.
org.hibernate.
org.hibernate.

event.internal

event.internal.
event.internal.

event.internal.

event.internal.

hibernate.CdmPreDataChangelistener.generateCaches (CdmPreDataChangelListener

hibernate.CacheStrategyGenerator.saveOrUpdateOrMerge (CacheStrategyGenerato

hibernate.CacheStrategyGenerator.onSaveOrUpdate (CacheStrategyGenerator. jav

internal.SessionImpl.fireSaveOrUpdate (SessionImpl. java:648)
internal.SessionImpl.saveOrUpdate (SessionImpl. java:640)
engine.spi.CascadingActions$5.cascade (CascadingActions. java:218)
engine.internal.Cascade.cascadeToOne (Cascade. java:398)
engine.internal.Cascade.cascadeAssociation(Cascade. java:323)
engine.internal.Cascade.cascadeProperty (Cascade. java:162)
engine.internal.Cascade.cascade (Cascade.java:111)
event.internal.

AbstractSaveEventListener.cascadeBeforeSave (AbstractSaveEventListener. java

.AbstractSaveEventListener.performSaveOrReplicate (AbstractSaveEventListener

AbstractSaveEventListener.performSave (AbstractSaveEventListener.java:178)
AbstractSaveEventListener.saveWithGeneratedId (AbstractSaveEventListener. ja

DefaultSaveOrUpdateEventListener.saveWithGeneratedOrRequestedId (DefaultSav

DefaultSaveEventListener.saveWithGeneratedOrRequestedId (DefaultSaveEventLi

.DefaultSaveOrUpdateEventListener.entityIsTransient (DefaultSaveOrUpdateEven

DefaultSaveEventListener.performSaveOrUpdate (DefaultSaveEventListener. java

DefaultSaveOrUpdateEventListener.onSaveOrUpdate (DefaultSaveOrUpdateEventLi

internal.SessionImpl.fireSave (SessionImpl. java:679)
internal.SessionImpl.save (SessionImpl.java:671)
internal.SessionImpl.save (SessionImpl. java:666)

eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.save (CdmEntityDaoBase.java:327)
eu.etaxonomy.cdm.api.service.ServiceBase.save (ServiceBase.java:268)

eu.etaxonomy.cdm.api.service.ServiceBase.save (ServiceBase. java:35)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)

org.springframework.
org.springframework.

.java:190)

at
7)
at

org.springframework.

org.springframework.

nterceptor. java:99)

at

org.springframework.

nAspectSupport. java:281)

at org.springframework.

6)

at org.springframework.
aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils.java:302)
aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodInvocation

aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15
transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI
transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio
transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9

aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
at
at
at
at
at
at
at

org.
com.
sun.
sun.
sun.

springframework.aop. framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:208)
sun.proxy.S$Proxy697.save (Unknown Source)
reflect.NativeMethodAccessorImpl.invokeO (Native Method)
reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

java.lang.reflect.Method.invoke (Method. java:498)
aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils.java:302)
aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodInvocation
.java:190)
at org.springframework.
at
at
org

.springframework.
.springframework.

.springframework.

java:78)

org
com.
sun.
sun.
sun.

.springframework.

aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15

remoting.support.RemoteInvocationTracelInterceptor.invoke (RemoteInvocationTraceInter

aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:208)
sun.proxy.S$Proxy983.save (Unknown Source)
reflect.NativeMethodAccessorImpl.invokeO (Native Method)
reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

java.lang.reflect.Method.invoke (Method. java:498)

org
org

.springframework.
.springframework.

utor.java:39)
at org.springframework.
.Java:78)

at org.springframework.
onBasedExporter. java:114)

at
org.
org.

at
at
.springframework.
74)

springframework.
springframework.
springframework.
springframework.
springframework.

remoting

remoting.
remoting.
remoting.
remoting.

web.servlet

.sup
sup

sup

sup

htt

web.servlet.

web.servlet
web.servlet

web.servlet.

port.RemoteInvocation.invoke (RemoteInvocation. java:212)
port.DefaultRemotelInvocationExecutor.invoke (DefaultRemotelInvocationExec

port.RemoteInvocationBasedExporter.invoke (RemoteInvocationBasedExporter
port.RemoteInvocationBasedExporter.invokeAndCreateResult (RemoteInvocati

pinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvokerServiceExp

.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdapter. java:51)

DispatcherServlet.doDispatch (DispatcherServlet. java:959)

.DispatcherServlet.doService (DispatcherServlet. java:893)
.FrameworkServlet.processRequest (FrameworkServlet. java:969)

FrameworkServlet.doPost (FrameworkServlet.java:871)

javax.servlet.http.HttpServlet.service (HttpServlet. java:707)
org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:845)
javax.servlet.http.HttpServlet.service (HttpServlet. java:790)

org

org.
org.

org.
eptor. java:
org.

.eclipse. jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

springframework.
springframework.

rceptor. java:90)

at

at

org

org.

Java:114)

at

at
122)

at

at
org.

org.

org

.springframework.
springframework.
springframework.
springframework.

springframework.

.springframework.security.web.

security.
security.
security.
security.
security.
security.

security.

web

ntextHolderAwareRequestFilter. java:169)

at org.springframework.security.web.

at org.springframework.security.web.

java:48)

at org.springframework.security.web.

at org.springframework.security.web.

henticationFilter. java:213)

at
at

at
at

at
at

org

org.

org.
org.

org.
org.

.springframework.
springframework.

springframework.
springframework.

springframework.
springframework.
web.

web.

web.

web.

web.

web.

eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1669)
springframework.security.web

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.Jjava:316
.access.intercept.FilterSecurityInterceptor.invoke (FilterSecurityInterc
access.intercept.FilterSecurityInterceptor.doFilter (FilterSecurityInte
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
access.ExceptionTranslationFilter.doFilter (ExceptionTranslationFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
session.SessionManagementFilter.doFilter (SessionManagementFilter. java:
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330
servletapi.SecurityContextHolderAwareRequestFilter.doFilter (SecurityCo
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
savedrequest .RequestCacheAwareFilter.doFilter (RequestCacheAwareFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

authentication.www.BasicAuthenticationFilter.doFilterInternal (BasicAut

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilter.java:120)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFilter. java:64)
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
at

at

org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330

org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (SecurityContextPersi

stenceFilter. java:91)

at

at

org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter.doFilterInterna

1 (WebAsyncManagerIntegrationFilter. java:53)

at
at
at
at
at
at
at

org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:107)
org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330

org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy.java:213)
org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)
org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. java:346)
org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:262)
org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFilter.java:12

org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
org.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1652)
org.eclipse. jetty.servlet.ServletHandler.doHandle (ServletHandler. java:585)
org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:143)
org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:577)

org.eclipse. jetty.server.session.SessionHandler.doHandle (SessionHandler. java:223)
org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:1127)
org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler. java:515)

org.eclipse. jetty.server.session.SessionHandler.doScope (SessionHandler. java:185)
org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler. java:1061)
org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler.java:141)

org.eclipse. jetty.server.handler.ContextHandlerCollection.handle (ContextHandlerCollection. java:215)
org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
org.eclipse.jetty.server.Server.handle (Server.java:497)

org.eclipse. jetty.server.HttpChannel.handle (HttpChannel. java:310)
org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)
org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)
org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
java.lang.Thread.run (Thread. java:748)
org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTraceIfPossible (RemoteInvoc

ationUtils.java:45)

at
at

org.springframework.remoting.support.RemoteInvocationResult.recreate (RemoteInvocationResult. java:149)
org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemoteInvocationResult (Remot

eInvocationBasedAccessor. java:85)

at

org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientIntercept

or.java:150)

at
9)

at

at

at

org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)
com.sun.proxy.$Proxy49.save (Unknown Source)
eu.etaxonomy.taxeditor.featuretree.ed.FeatureTreeEditor$AddButtonListener.widgetSelected (FeatureTreeEdi

tor.java:166)

at
at
at

org.eclipse.swt.widgets.TypedListener.handleEvent (TypedListener. java:249)
org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

After reloading the feature tree the new feature exists. However, the error pops up and without reloading the new feature is not shown in the tree.

#26 - 06/21/2017 12:29 AM - Andreas Miiller

and when deleting a feature | get an NPE:

login

editor
server
schema

admin
version : 4.8.0.201706201949
test.e-taxonomy.eu (edit-test) / rem_conf_am
version : 4.7.0.0.201710040000

os : Windows Server 2012 R2 6.3 amdo64

java

1.8.0_121

java.lang.NullPointerException

at
at
at
at
at
at

eu.etaxonomy.cdm.api.service.FeatureNodeServiceImpl.isDeletable (FeatureNodeServiceImpl. java:103)
eu.etaxonomy.cdm.api.service.FeatureNodeServiceImpl.deleteFeatureNode (FeatureNodeServiceImpl. java:56)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokedJoinpoint (ReflectiveMethodInvocation
.Java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15
7)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI
nterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio
nAspectSupport. java:281)

#27 - 06/21/2017 12:29 AM - Andreas Miiller
- % Done changed from 90 to 70

#28 - 06/21/2017 12:32 AM - Andreas Muller
Andreas Muller wrote:
and when deleting a feature | get an NPE:

login : admin

This only happens for NON top level feature (feature which do have a parent).

#29 - 06/21/2017 12:42 AM - Andreas Miiller

Adding a new top level feature is not possible once a feature node is selected
#30 - 06/21/2017 12:47 AM - Andreas Miiller
Supplemental data are not yet shown (view is grey). It will not show many data but created, id and uuid might be very helpful, at least for debugging.
Also the details view might be needed for editing "inapplicablelf" and "onlyApplicablelf". Feel free to open new tickets for these issues.
#31 - 06/21/2017 12:48 AM - Andreas Miiller
Andreas Miller wrote:

Patrick Plitzner wrote:

2 problems:

e even if NO feature tree is selected the field can still be edited (this does not make sense)

¢ if the search dialog button is just beside the field it is not intuitive that this is an editing field. Search and editing should be clearly separated.
Can we have a search section and an editing section which are separated? Also the search part should have an according label "Search"

The search button is still beside the titleCache button

#32 - 06/21/2017 12:50 AM - Andreas Muller

Also for the trees themselves no supplemental data and details view is available, but might be a nice feature.
#33 - 06/21/2017 07:52 AM - Patrick Plitzner
Andreas Miller wrote:

Adding a new top level feature is not possible once a feature node is selected

To do this you have to de-select the current feature (CTRL+Click on the selected item) or just move it to root after having added it
#34 - 06/21/2017 07:55 AM - Patrick Plitzner
Andreas Muller wrote:

Supplemental data are not yet shown (view is grey). It will not show many data but created, id and uuid might be very helpful, at least for
debugging.

Also the details view might be needed for editing "inapplicablelf" and "onlyApplicablelf". Feel free to open new tickets for these issues.
Added new ticket: #6746
#35 - 06/21/2017 09:31 AM - Andreas Muller
Patrick Plitzner wrote:

Andreas Muller wrote:

Adding a new top level feature is not possible once a feature node is selected
To do this you have to de-select the current feature (CTRL+Click on the selected item) or just move it to root after having added it
As adding top level elements makes 98% of the work you do in the feature tree editor this is not an acceptable solution. CTRL+Click is hidden
knowledge which we can't expect the user to have. Moving it to root is a workaround users may find, but not very nice.
There might be different solutions: my preferred one is to have a right click menu like in the term editor and in many other editors and views. This
would be more consistent throughout the application. It was ok to have "+" Button when the FeatureTree Editor was still in the preferences as most
preferences work with "+". But now it is an "editor" and should follow the look and feel of editors.

We can still keep the buttons but additionally could have a right click menu.

Another solution could be to allow toggle focus without having CTRL pressed (only by clicking). This makes it a bit easier to find. But still this is not
really intuitive.

A third solution could be to always add features as top level elements and move them manually to the place were you need them. For the current use
cases this is absolutely enough as it is very seldom that users really build trees. Usually they build lists. But for use cases like "additivity" this might be
different.

Another solution could be 2 different button, one for top level one for children, but this is also not consistent with other editors (and maybe not
intuitive)

#36 - 06/21/2017 10:01 AM - Patrick Plitzner
- Assignee changed from Patrick Plitzner to Andreas Mliller
Andreas Muller wrote:
Patrick Plitzner wrote:
Andreas Muller wrote:

Adding a new top level feature is not possible once a feature node is selected

To do this you have to de-select the current feature (CTRL+Click on the selected item) or just move it to root after having added it

As adding top level elements makes 98% of the work you do in the feature tree editor this is not an acceptable solution. CTRL+Click is hidden
knowledge which we can't expect the user to have. Moving it to root is a workaround users may find, but not very nice.

There might be different solutions: my preferred one is to have a right click menu like in the term editor and in many other editors and views. This
would be more consistent throughout the application. It was ok to have "+" Button when the FeatureTree Editor was still in the preferences as
most preferences work with "+". But now it is an "editor" and should follow the look and feel of editors.

We can still keep the buttons but additionally could have a right click menu.

Another solution could be to allow toggle focus without having CTRL pressed (only by clicking). This makes it a bit easier to find. But still this is
not really intuitive.

A third solution could be to always add features as top level elements and move them manually to the place were you need them. For the current
use cases this is absolutely enough as it is very seldom that users really build trees. Usually they build lists. But for use cases like "additivity" this
might be different.

Another solution could be 2 different button, one for top level one for children, but this is also not consistent with other editors (and maybe not

intuitive)

Now new features are added to root always. Also the other session issues should be fixed now. But there were also cdmlib changes so you have to
wait for the build if you test on the test DB

#37 - 07/07/2017 06:32 PM - Andreas Miiller

- Precedes bug #6786: Remaining feature tree editor issues added
https://dev.e-taxonomy.eu/redmine/issues/6746

#38 - 07/07/2017 07:15 PM - Andreas Miiller
- Status changed from Feedback to Closed

- Assignee changed from Andreas Miiller to Patrick Plitzner

| close this ticket as there was a release and open a new one with remaining issues: #6786

Also some new issues were found. The most important issues are marked as critical and should be handled soon.

#39 - 07/21/2017 01:29 PM - Andreas Miiller
- Related to feature request #6805: Implement drag and drop from Term Editor (Feature) to FeatureTreeEditor added

#40 - 07/21/2017 01:29 PM - Andreas Miiller
- Related to feature request #6806: Add context menu to FeatureTreeEditor added

#41 - 07/21/2017 01:34 PM - Andreas Miiller
- Related to bug #6838: Implement i18n for Feature TreeEditor added

#42 - 07/22/2017 08:40 AM - Andreas Miiller

- Related to bug #6844: New feature tree selection does not allow "no save" added

#43 - 07/22/2017 08:58 AM - Andreas Miiller
- Related to bug #6845: dirty button does not work in feature tree editor added

#44 - 09/26/2017 04:51 PM - Patrick Plitzner
- % Done changed from 70 to 100
